{******************************************************
 Fulgore's Misc Components
 Freeware. Copyright(c) 2000 by Eli Yukelzon
 If you want to use this code, please first email me at:
                  eli@yukelzon.com
 Component Info:
 Wallpaper Changer - 
 Morronic component, that was wrote for my Litestep module.
 Anyhow, if you find it useful.... It's you luck then...
 ******************************************************}

unit fmWp;

interface

uses
  Windows,Dialogs, Messages, SysUtils, Classes ;

type

  TfmWPChange = class(TComponent)
  private
     FFileName : TFileName ;
     FFileDir : string ;
     procedure SetFileDir(s : string) ;
     procedure SetFileName(s : TFileName) ;
  public
     procedure ResetWindowsDir ;
     constructor Create(AOwner : TComponent) ; override ;
     procedure Execute ; virtual ;
  published
     property FileDir : string read FFileDir write SetFileDir ;
     property FileName : TFileName read FFileName write SetFileName ;
  end;


implementation

constructor TfmWPChange.Create(AOwner : TComponent) ;
begin
     inherited Create(AOwner) ;
     ResetWindowsDir ;
end ;

procedure TfmWPChange.ResetWindowsDir ;
var
   p : PChar ;
begin
     p := StrAlloc(255) ;
     GetWindowsDirectory(p, 255) ;
     FFileDir := string(p) ;
     StrDispose(p) ;
end ;

procedure TfmWPChange.SetFileName(s : TFilename);
begin
     if FileExists(s) and (UpperCase(ExtractFileExt(s)) = '.BMP') then
        FFileName := s ;
end ;

procedure TfmWPChange.SetFileDir(s : string) ;
var
   SearchRec: TSearchRec;
begin
     { make sure there are actually BMP files in target directory }
     if FindFirst(s + '\*.bmp', faAnyFile, SearchRec) = 0 then
        FFileDir := s ;
     FindClose(SearchRec) ;
end ;

procedure TfmWPChange.Execute ;
var
   BMPFile : string ;
   SearchRec: TSearchRec;
   Files : TStringList ;
begin
     if FFileName <> '' then
        SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, PChar(FFileName),
                             SPIF_UPDATEINIFILE or SPIF_SENDWININICHANGE)
     else begin
        Files := TStringList.Create ;
        if FindFirst(FFileDir + '\*.bmp', faAnyFile, SearchRec) = 0 then begin
           Files.Add(SearchRec.Name) ;
           while FindNext(SearchRec) = 0 do
              Files.Add(SearchRec.Name) ;
        end ;
        FindClose(SearchRec) ;
        if Files.Count > 0 then begin
           Randomize ;
           BMPFile := Files[ Trunc(Random(Files.Count - 1)) ] ;
           SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, PChar(BMPFile),
                                SPIF_UPDATEINIFILE or SPIF_SENDWININICHANGE) ;
        end ;
        Files.Free ;
     end ;
end ;

end.
